' This class is "generated" and will be overwritten.
' Your customizations should be made in Order_DetailsRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace UseDAL.Business

''' <summary>
''' The generated superclass for the <see cref="Order_DetailsRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="Order_DetailsTable"></see> class.
''' </remarks>
''' <seealso cref="Order_DetailsTable"></seealso>
''' <seealso cref="Order_DetailsRecord"></seealso>

<Serializable()> Public Class BaseOrder_DetailsRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As Order_DetailsTable = Order_DetailsTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Function GetOrderIDValue() As ColumnValue
		Return Me.GetValue(TableUtils.OrderIDColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Function GetOrderIDFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.OrderIDColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Sub SetOrderIDFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.OrderIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Sub SetOrderIDFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.OrderIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Sub SetOrderIDFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.OrderIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Sub SetOrderIDFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.OrderIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Sub SetOrderIDFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.OrderIDColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Function GetProductIDValue() As ColumnValue
		Return Me.GetValue(TableUtils.ProductIDColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Function GetProductIDFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.ProductIDColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Sub SetProductIDFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ProductIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Sub SetProductIDFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.ProductIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Sub SetProductIDFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ProductIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Sub SetProductIDFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ProductIDColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Sub SetProductIDFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ProductIDColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Function GetUnitPriceValue() As ColumnValue
		Return Me.GetValue(TableUtils.UnitPriceColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Function GetUnitPriceFieldValue() As Decimal
		Return CType(Me.GetValue(TableUtils.UnitPriceColumn).ToDecimal(), Decimal)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Sub SetUnitPriceFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.UnitPriceColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Sub SetUnitPriceFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.UnitPriceColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Sub SetUnitPriceFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.UnitPriceColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Sub SetUnitPriceFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.UnitPriceColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Sub SetUnitPriceFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.UnitPriceColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Function GetQuantityValue() As ColumnValue
		Return Me.GetValue(TableUtils.QuantityColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Function GetQuantityFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.QuantityColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Sub SetQuantityFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.QuantityColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Sub SetQuantityFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.QuantityColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Sub SetQuantityFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.QuantityColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Sub SetQuantityFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.QuantityColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Sub SetQuantityFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.QuantityColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Function GetDiscountValue() As ColumnValue
		Return Me.GetValue(TableUtils.DiscountColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Function GetDiscountFieldValue() As Single
		Return CType(Me.GetValue(TableUtils.DiscountColumn).ToSingle(), Single)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Sub SetDiscountFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.DiscountColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Sub SetDiscountFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.DiscountColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Sub SetDiscountFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.DiscountColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Sub SetDiscountFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.DiscountColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Sub SetDiscountFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.DiscountColumn)
	End Sub


#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Order_Details_.OrderID field.
	''' </summary>
	Public Property OrderID() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.OrderIDColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.OrderIDColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property OrderIDSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.OrderIDColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property OrderIDDefault() As String
        Get
            Return TableUtils.OrderIDColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Order_Details_.ProductID field.
	''' </summary>
	Public Property ProductID() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.ProductIDColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.ProductIDColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ProductIDSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ProductIDColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ProductIDDefault() As String
        Get
            Return TableUtils.ProductIDColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Order_Details_.UnitPrice field.
	''' </summary>
	Public Property UnitPrice() As Decimal
		Get 
			Return CType(Me.GetValue(TableUtils.UnitPriceColumn).ToDecimal(), Decimal)
		End Get
		Set (ByVal val As Decimal) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.UnitPriceColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property UnitPriceSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.UnitPriceColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property UnitPriceDefault() As String
        Get
            Return TableUtils.UnitPriceColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Order_Details_.Quantity field.
	''' </summary>
	Public Property Quantity() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.QuantityColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.QuantityColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property QuantitySpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.QuantityColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property QuantityDefault() As String
        Get
            Return TableUtils.QuantityColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Order_Details_.Discount field.
	''' </summary>
	Public Property Discount() As Single
		Get 
			Return CType(Me.GetValue(TableUtils.DiscountColumn).ToSingle(), Single)
		End Get
		Set (ByVal val As Single) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.DiscountColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property DiscountSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.DiscountColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property DiscountDefault() As String
        Get
            Return TableUtils.DiscountColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
